<template>
<v-col cols='12' class='pa-0'>
    <v-card
        class='ma-1'
        min-width="256"
    >
        <v-card-title>
        Radio
        </v-card-title>
        <v-card-text>
        <v-row>
            <v-col>
                <v-card min-width="280">
                    <v-card-title>
                        Signal
                    </v-card-title>
                    <v-card-text>
                        <v-slider
                            v-model="confArchRadius"
                            color="rgb(255, 0, 0)"
                            track-color="black"
                            label="Radius"
                            step="0.1"
                            max="359"
                            min="0.1"
                        ></v-slider>
                        <v-slider
                            v-model="confDirection"
                            color="rgb(255, 0, 0)"
                            track-color="black"
                            :label="`Direction ${confDirection}`"
                            step="1"
                            max="180"
                            min="-180"
                        ></v-slider>
                        <v-row justify="center">
                            <canvas ref="ctxConf" :width="confW" :height="confH" style="border:1px solid #000000;"></canvas>
                        </v-row>
                    </v-card-text>
                </v-card>
            </v-col>
            <v-col>
                <v-card min-width="280">
                    <v-card-title>
                        Signal
                    </v-card-title>
                    <v-card-text>
                        <v-slider
                            v-model="amplitude"
                            color="rgb(255, 0, 0)"
                            track-color="black"
                            label="Amplitude"
                            step="0.1"
                            max="25"
                        ></v-slider>
                        <v-slider
                            v-model="skipBig"
                            color="rgb(255, 0, 0)"
                            track-color="black"
                            label="Skipping big"
                            step="1"
                            max="500"
                            min="1"
                        ></v-slider>
                        <v-row justify="center">
                            <canvas ref="ctxChart" width="500" height="500" style="border:1px solid #000000;"></canvas>		
                        </v-row>
                    </v-card-text>
                </v-card>
            </v-col>
        </v-row>
        </v-card-text>
    </v-card>
</v-col>
</template>

<script>
export default {
    data() {
        return {
            conf: null,
            confRadius: 200,
            confW: 500,
            confH: 500,
            confArchRadius: 0.1,
            confDirection: 0,

            chart: null,
            interval: null,
            amplitude: 1,
            skipBig: 1,

            debounced: {
                archRadius: null,
                direction: null
            }
        }
    },
    mounted() {
        this.debounced.archRadius = _.debounce(() => {
            this.$socket.emit("radar.archRadiusSet", this.confArchRadius)
        }, 100);
        this.debounced.direction = _.debounce(() => {
            this.$socket.emit("radar.directionSet", this.confDirection)
        }, 100);

        this.chart = this.$refs.ctxChart.getContext("2d")
        this.conf = this.$refs.ctxConf.getContext("2d")
        const chart = this.chart
        const conf = this.conf
        chart.fillStyle = "#000000"
        conf.fillStyle = "#000000"
        chart.fillRect(0,0,500,500);
        conf.fillRect(0,0,500,500);

        this.interval = setInterval(this.tick, this.frequency)
        this.drawConfig()
    },
    methods: {
        drawConfig() {
            const center = {
                x: this.confW / 2,
                y: this.confH / 2
            }

            this.conf.fillStyle = "#000000"
            this.conf.fillRect(0,0,500,500);

            //configure hearing direction
            const dividedArch = this.confArchRadius / 2
            const beginAngle = this.dtr(-90 + this.confDirection - dividedArch)
            const endAngle = this.dtr(-90 + this.confDirection + dividedArch)

            this.conf.lineWidth = 1;
            this.conf.strokeStyle = "#00aa00"
            this.conf.beginPath();
            this.conf.moveTo(center.x, center.y);
            // this.conf.lineTo(Math.sin(beginAngle * this.confRadius), Math.cos(beginAngle * this.confRadius));
            this.conf.arc(250, 250, this.confRadius - 10, beginAngle, endAngle);
            this.conf.closePath();
            this.conf.stroke();
            this.conf.fillStyle = "#009900"
            this.conf.fill();
            //End configure hearing direction

            this.conf.strokeStyle = "#00ff00"
            this.conf.lineWidth = 3;
            this.conf.beginPath();
            this.conf.arc(250, 250, this.confRadius, 0, this.dtr(360));
            this.conf.stroke();
            this.conf.closePath();
        },
        tick (){
            //chart
            this.chart.fillStyle = "#000000"
            this.chart.fillRect(0,0,500,500);
            this.chart.strokeStyle = "#00aa00"
            this.chart.lineCap = 'round';
            this.chart.lineJoin = 'round';
            this.chart.beginPath();
            this.chart.moveTo(0, 250);
            const adder = this.skipBig
            for(let i = 0; i < 500; i += adder) {
                let storageIndex = this.radio.emissionStorage.length > 500 ? this.radio.emissionStorage.length - 500 + i : i
                // let storageIndexPrev = this.radio.emissionStorage.length > 500 ? this.radio.emissionStorage.length - 500 + i - adder : i - adder
                const levelComputed = this.radio.emissionStorage[storageIndex] * this.amplitude || 0
                // const levelComputedPrev = this.radio.emissionStorage[storageIndexPrev] * this.amplitude || 0
                // console.log(levelComputed)
                const y = 250 + levelComputed
                this.chart.lineTo(i, y);
                // const iCenter = i-(adder/2)
                // const yCenter = 2/(levelComputed+levelComputedPrev)
                // this.chart.bezierCurveTo(iCenter, levelComputedPrev + 250, iCenter, y, i, y);
            }
            this.chart.stroke(); 
            this.chart.closePath();
            //chart end
        },
    },
    watch: {
        confArchRadius() {
            this.debounced.archRadius();
            this.drawConfig()
        },
        confDirection() {
            this.debounced.direction();
            this.drawConfig()
        }
    },
    computed: {
        frequency() {
            return this.$store.getters.get_server_tick_frequency
        },
        radio() {
            return this.$store.getters.radio
        }
    },
    name: 'radio-receiver-card'
}
</script>